Script name:   BASTION
Author:  Alexey Sereda (news@ant.kiev.ua)
Target:  Mail filter 
Realization: Perl

About 
------
BASTION is a Perl script that filtered all e-mail traffic between
Sendmail and local mailer Procmail to remove suspicious messages. 
Script detect hazard attachments (executive files etc.) and mostly
malicious HTML tags in message, removed it, notify recepient and 
sender about lost content and make copy of message in specified 
location for further analize.
Script also support such security options as "black list" e-mail
addresses and unwanted words in <subj> field. 

Installation
------------
The installation of BASTION is very simple and consist of next steps:

1) You must put 'BASTION' in any permissible location, usually -
/usr/local/bin (it's good idea).

2) If necessary, create directory for BASTION's config files, that  
may bee, in example /usr/local/etc/bastion, and place in following
files:
 - nongrata - for list of forbidden e-mail address (from you dont want 
   acsept messages;
 - nonsubj - for list of words, forbidden in <subj> field.
To create directory make command:

#mkdir /usr/local/etc/bastion 

or you desired location.
 
3) Modify your 'sendmail.cf' to permit mail filtration. Usually it
location in /etc/sendmail.cf. Your must changed following strings: 

Original sendmail.cf
---------------------
Mlocal, P=/usr/bin/procmail, F=lsDFMAw5:/|@qShP, S=10/30, R=20/40,
        T=DNS/RFC822/X-Unix,
        A=procmail -a $h -d $u

Modified sendmail.cf
---------------------
Mlocal, P=/usr/local/bin/bastion, F=lsDFMAw5/|@qShP, S=10/30, R=20/40,
        T=DNS/RFC822/X-Unix,
        A=bastion -a $h -d $u

4) Verify, that place of config files correspond with pointed in 
programm text. 

5) Restart sendmail daemon.

If you want switch on options, change initialing value of variables 
 - $nongrata to "black list" option
 - $nonsubj to <subj> field analize
in BASTION text from '0' to '1'. 

Notify me about all bugs and troubles with BASTION.
Thank you and good luck!

Alexey Sereda
news@ant.kiev.ua
